# PreZ v1.0 - FreeBSD Version
# This is the part that maps the memory and spawns a new thread

.equ    SYS_rfork, 251
.equ    SYS_mmap, 477

.equ    PROT_READ, 0x1
.equ    PROT_WRITE, 0x2
.equ    PROT_EXEC, 0x4

.equ    MAP_PRIVATE, 0x2
.equ    MAP_ANON, 0x1000

.equ    RFPROC, (1<<4)
.equ    RFTHREAD, (1<<13)
.equ    RFMEM,(1<<5)
.equ    RFSIGSHARE, (1<<14)

.text

.global _start

# Change the int3 at the parent to something like 'jmp .' to run this
# as a normal program.
_start:

# Map space
    pushl   $0
    pushl   $-1
    pushl   $(MAP_PRIVATE | MAP_ANON)
    pushl   $(PROT_READ | PROT_WRITE | PROT_EXEC)
    pushl   $8192
    pushl   $0
    pushl   $0
    movl    $SYS_mmap, %eax
    int     $0x80
    addl    $28, %esp

# %eax holds a pointer to the mmapped space, keep it
    movl    %eax, %edi

# Copy the code
# Trick to get the address of the code
    jmp     fw
bw:
    popl    %ebx
    movl    $INJ_SIZE, %ecx
move_next:
    movb    (%ebx), %dl
    movb    %dl, (%eax)
    inc     %eax
    inc     %ebx
    loop    move_next

# Now we must rfork and create the thread

    pushl   $(RFPROC | RFTHREAD | RFMEM | RFSIGSHARE)
    pushl   $0
    movl    $SYS_rfork, %eax
    int     $0x80
    addl    $8, %esp
# It's the child thread, setup stack and call the copied code
    cmpl    $0, %edx
    jnz     child

# It's the father
    addl    $8, %esp

# Jump to injector
    int3

child:
    movl    %edi, %esp
    addl    $(8192 - 4), %esp
    movl    %esp, %ebp
    jmp     *%edi

fw:
    call    bw

injected:

.include "code.s"

injected_end:

.equ    INJ_SIZE, injected_end - injected
