# PreZ v1.0 - Linux Version
# This is the part that maps the memory and spawns a new thread
.equ    SYS_mmap2, 192
.equ    SYS_clone, 120
.equ    SYS_write, 4
.equ    SYS_fork, 2
.equ    SYS_close, 6
.equ    SYS_execve, 11
.equ    SYS_dup2, 63

.equ    PROT_READ, 0x1
.equ    PROT_WRITE, 0x2
.equ    PROT_EXEC, 0x4

.equ    MAP_PRIVATE, 0x2
.equ    MAP_ANONYMOUS, 0x20

.equ    CLONE_VM, 0x100
.equ    CLONE_FS, 0x200
.equ    CLONE_FILES, 0x400
.equ    CLONE_SIGHAND, 0x800
.equ    CLONE_PARENT, 0x8000
.equ    CLONE_THREAD, 0x10000
.equ    CLONE_IO, 0x80000000

.text

.globl _start

# Change the int3 at the parent to something like 'jmp .' to run this
# as a normal program.
_start:

# Map space, 8192 bytes is more than enough for our code
    movl    $SYS_mmap2, %eax
    xorl    %ebx, %ebx
    movl    $8192, %ecx
    movl    $(PROT_READ | PROT_WRITE | PROT_EXEC), %edx
    movl    $(MAP_PRIVATE | MAP_ANONYMOUS), %esi
    movl    $-1, %edi
    xorl    %ebp, %ebp
    int     $0x80

# %eax holds a pointer to the mmapped space, keep it
    movl    %eax, %edi

# Copy our code
# Trick to get the address of the code
    jmp     fw
bw:
    popl    %esi
    movl    $INJ_SIZE, %ecx
move_next:
    movb    (%esi), %bl
    movb    %bl, (%edi)
    inc     %esi
    inc     %edi
    loop    move_next

# Cloning is a little bit difficult
    movl    %eax, %ebp
# Prepare stack
    movl    %eax, %ecx
    addl    $(8192 - 4), %ecx
    movl    %eax, (%ecx)
# Stack is ok, now continue with the rest of the arguments
    movl    $(CLONE_VM | CLONE_FS | CLONE_FILES | CLONE_SIGHAND | CLONE_THREAD), %ebx
    xorl    %edx, %edx
    xorl    %esi, %esi
    xorl    %edi, %edi
    movl    $SYS_clone, %eax
    int     $0x80

    test    %eax, %eax
    jnz     parent_cont
# We will now make the corrent %ebp and %esp and jump to the thread
    movl    %ebp, %eax
    addl    $(8192 - 8), %ebp
    movl    %ebp, %esp
    jmp     *%eax

parent_cont:

# We're done, back to the injector
    int3
fw:
    call    bw

injected:

.include "code.s"

injected_end:

.equ    INJ_SIZE, injected_end - injected
